#!/usr/bin/perl

my @ColorPalette = (
  [ 117, 195, 255 ],
  [   0,   0, 255 ],
  [ 255, 255, 255 ],
  [ 255,   0,   0 ],
  [ 255,   0, 174 ],
  [ 179,   0,   0 ],
  [ 0,   255,   0 ],
  [ 255, 255,   0 ],
  [ 235,   0,   0 ],
  [   0, 162,   0 ],
  [ 255,   0, 255 ],
  [ 100, 100, 177 ],
  [ 172, 174,  41 ],
  [ 255, 144,  26 ],
  [   2, 255, 177 ],
  [ 192, 224,   0 ],
  [  66,  66,  66 ],
  [ 189, 168, 100 ],
  [  95, 200,   0 ],
  [ 203,  60,  69 ],
  [   0, 109, 255 ],
  [ 200,  61,  68 ],
  [ 200,  66,   0 ],
  [   0,  41,   0 ],
  [ 139, 121, 177 ],
  [ 116, 116, 116 ],
  [ 200,  50,  89 ],
  [ 255, 171,  98 ],
  [   0,  68, 189 ],
  [  52,  43,   0 ],
  [ 255,  46,   0 ],
  [ 100, 216,  32 ],
  [   0,   0, 112 ],
  [ 105, 105,   0 ],
  [ 132,  75, 255 ],
  [ 184, 232,   0 ],
  [   0, 109, 112 ],
  [ 189, 168, 100 ],
  [ 132,  75,  75 ],
  [ 255,  75,  75 ],
  [ 255,  20,   0 ],
  [  52,   0,   0 ],
  [   0,  66,   0 ],
  [ 184, 132,   0 ],
  [ 100,  16,  32 ],
  [ 146, 255, 255 ],
  [   0,  23,  37 ],
  [ 146,   0, 255 ],
  [   0, 138, 119 ],
);

my $MAX_COLORS = @ColorPalette;

sub RGB2Hex {
    $red=$_[0];
    $green=$_[1];
    $blue=$_[2];
    $string=sprintf ("#%2.2X%2.2X%2.2X",$red,$green,$blue);
    return ($string);
}

sub GetParaverColor 
{
  my ($Color) = @_;
  $Color ++;
  if ($Color < 0) 
  {
    $Color = 0;
  }
  if ($Color > $MAX_COLORS) 
  {
    $Color = $MAX_COLORS-1;
  }
  return RGB2Hex($ColorPalette[$Color][0], $ColorPalette[$Color][1], $ColorPalette[$Color][2]);
}

